﻿Imports System.Xml

''' <summary>
''' Pomocny modul pro vysky
''' </summary>
''' <remarks></remarks>
Module Vysky
    Public seznamVysek() As String = {"C", "Cis", "D", "Dis", "E", "F", "Fis", "G", "Gis", "A", "Ais", "H", "c", "cis", "d", "dis", "e", "f", "fis", "g", "gis", "a", "ais", "h"}
    ''' <summary>
    ''' Zjisti index vysky z textu
    ''' </summary>
    ''' <param name="vyska"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetVyskaIndexFromText(ByVal vyska As String) As Integer
        For a As Integer = 0 To seznamVysek.Length - 1
            If vyska = seznamVysek(a) Then Return a + 1
        Next
        Throw New Exception() ' nenalezeno
    End Function
    ''' <summary>
    ''' Zjisti text vysky z indexu
    ''' </summary>
    ''' <param name="index">1..n</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetVyskaTextFromIndex(ByVal index As Integer) As String
        If index < 0 Or index > seznamVysek.Length Then Throw New Exception()
        Return seznamVysek(index)
    End Function
End Module

Public Class noty

    ''' <summary>
    '''  element (nota nebo pomlka - pomlka pokud je vyska 0)
    ''' </summary>
    ''' <remarks></remarks>
    Public Structure elm
        Public delka As Single
        Public vyska As Integer
        Public skok As Single ' obloucek pro skok (neni, pokud je 0)
    End Structure

    Public Takt As Integer

    Public skladba As New Generic.List(Of elm)

    ''' <summary>
    ''' Nacte XML se skladbou do datovych struktur
    ''' </summary>
    ''' <param name="flName">Ceska k souboru</param>
    ''' <returns>Pokud vraci String.Empty, je operace v poradku provedena</returns>
    ''' <remarks></remarks>
    Public Function Load(ByVal flName As String) As String
        skladba = New Generic.List(Of elm)

        ' otevreni dokumentu
        Dim xmldoc As New XmlDocument()
        Try
            xmldoc.Load(flName)
        Catch
            Return "Nepodaril se otevrit soubor!"
        End Try

        ' nacteni taktu
        Try
            Dim TaktS As String
            TaktS = xmldoc.FirstChild.Attributes("takt").Value
            If TaktS <> "3/4" And TaktS <> "4/4" And TaktS <> "5/4" Then Throw New Exception()
            Takt = Val(TaktS.Substring(0, 1))
        Catch
            Return "Spatny takt!"
        End Try

        ' cteni not a pomlk
        Dim actPos As Single = 0
        Try
            For Each nd As XmlNode In xmldoc.FirstChild.ChildNodes
                Dim nElm As New elm
                nElm.vyska = 0 : nElm.delka = 0 : nElm.skok = 0

                If nd.Name = "nota" Then
                    Dim oldPos As Integer = actPos
                    nElm.delka = Val(nd.Attributes("delka").Value)
                    nElm.vyska = Vysky.GetVyskaIndexFromText(nd.Attributes("vyska").Value)
                    Dim skokCounter As Integer = 0

                    Do While Int(actPos / Takt) <> Int((nElm.delka + actPos - 0.1) / Takt)
                        Dim el2 As New elm
                        skokCounter += 1
                        el2.skok = 0 : el2.vyska = nElm.vyska : el2.delka = Takt - (actPos Mod Takt)
                        skladba.Add(el2)
                        actPos += el2.delka
                        nElm.delka -= el2.delka
                    Loop

                    If nElm.delka <> 0 Then
                        actPos += nElm.delka
                        skladba.Add(nElm)
                        If skokCounter <> 0 Then
                            Dim elmM As elm = skladba.Item(skladba.Count - 1 - skokCounter)
                            elmM.skok = skokCounter
                            skladba.RemoveAt(skladba.Count - 1 - skokCounter)
                            skladba.Insert(skladba.Count - 1 - skokCounter + 1, elmM)
                        End If
                    End If
                ElseIf nd.Name = "pomlka" Then
                    nElm.delka = Val(nd.Attributes("delka").Value)
                    Dim skokCounter As Integer = 0

                    Do While Int(actPos / Takt) <> Int((nElm.delka + actPos - 0.1) / Takt)
                        Dim el2 As New elm
                        el2.skok = 0 : el2.vyska = 0 : el2.delka = Takt - (actPos Mod Takt)
                        skladba.Add(el2)
                        actPos += el2.delka
                        nElm.delka -= el2.delka
                    Loop

                    If nElm.delka <> 0 Then
                        actPos += nElm.delka
                        skladba.Add(nElm)
                    End If
                End If
            Next
        Catch
            Return "Chyba v zapisu not nebo taktu!"
        End Try

        ' uspesne nacteni
        Return String.Empty
    End Function
    Public Function save(ByVal flName As String) As String
        Try
            Dim flw As IO.StreamWriter = IO.File.CreateText(flName)
            flw.WriteLine("<skladba takt=""" & Takt & "/4"">")
            For Each t As elm In skladba
                If t.vyska = 0 Then
                    flw.WriteLine("<pomlka delka=""" & t.delka.ToString.Replace(",", ".") & """/>")
                Else
                    flw.WriteLine("<nota vyska=""" & Vysky.GetVyskaTextFromIndex(t.vyska - 1) & """ delka=""" & t.delka.ToString.Replace(",", ".") & """/>")
                End If
            Next
            flw.WriteLine("</skladba>")
            flw.Close()
        Catch
            Return "Chyba"
        End Try
        Return String.Empty
    End Function
End Class
